#ifndef ACTOR_H
#define ACTOR_H


/*an actor represents an object in the world. This class is abstract.*/
class Actor
{
public:
    /*constructor: it creates an actor that a rectangle*/
    Actor(int axleft, int aytop, int awidth, int aheight);


    virtual ~Actor();

    /*draw the actor*/
    virtual void draw() = 0;

    /*one step of computation*/
    virtual void step() = 0;

    /*interaction with another actor*/
    virtual void interact(Actor* actor) = 0;


/*accessing to the value of the rectangle*/
    void setXleft(int aleft);
    int getXLeft();

    void setXright(int axright);
    int getXRight();

    void setYTop(int aytop);
    int getYTop();

    void setYBottom(int aybottom);
    int getYBottom();


/*returns true if the current actor intersects actor r*/
    bool isIntersect(Actor* r);

/*returns true if the current actor is over (walks over) actor r*/
    bool isOver(Actor* r);


protected:


private:

    int xleft;
    int ytop;
    int width;
    int height;
};

#endif // ACTOR_H
