#ifndef WORLD_H
#define WORLD_H

#include "Actor.h"
#include <vector>


using namespace std;

/*a world of a game*/
class World
{
public:
    World();
    virtual ~World();

    /*draw the world*/
    void draw();

    /*makes one step of computation*/
    void step();

    /*add an actor*/
    void addActor(Actor* actor);

    /*delete an actor (you should never delete an action directly but use this method*/
    void deleteActor(Actor* actor);

    /*returns true if you loose*/
    virtual bool isGameover() = 0;

    /*returns true if you win*/
    virtual bool isWon() = 0;

protected:
private:
    vector<Actor*> actors;
    vector<Actor*> actorsToDelete;

    /*effectively delete all actors that should be deleted*/
    void deleteActorsToDelete();

    /*draw the background*/
    void drawBackground();
};

#endif // WORLD_H
