#include "Player.h"
#include <iostream>


Player::Player(int axleft, int aytop) : Rectangle(axleft, aytop, 32, 32)
{
    //ctor
}

Player::~Player()
{
    //dtor
}



void Player::moveLeft()
{
    setXleft(getXLeft() - 1);
}

void Player::moveRight()
{
    setXleft(getXLeft() + 1);
}


void Player::jump()
{
    if(jumping_state == 0 && overSomething)
    {
        jumping_state++;
        overSomething = false;
    }
}






void Player::step()
{
    setYTop(getYTop() + 3);
    color = al_map_rgb(255, 128, 0);

    overSomething = false;
    if(jumping_state != 0)
    {
        if(jumping_state < 40)
            jumping_state++;
        else if(jumping_state >= 40)
            jumping_state = 0;
    }

    if(jumping_state > 0)
    {
        setYTop(getYTop() - 10 + jumping_state/4);
    }
}



void Player::interact(Actor* actor)
{
    if(isOver(actor) && jumping_state <= 0)
    {
        overSomething = true;
        setYBottom(actor->getYTop());

    }


    if(overSomething)
        color = al_map_rgb(255, 255, 0);
}
