#include "World.h"
#include <algorithm>
#include "allegro5/allegro_primitives.h"


World::World()
{

}

void World::drawBackground()
{
    al_clear_to_color(al_map_rgb(128, 192, 255));
}




void World::draw()
{
    drawBackground();


    for (vector<Actor*>::iterator actorIt = actors.begin(); actorIt != actors.end(); ++actorIt)
    {
        (*actorIt)->draw();

    }

}

void World::step()
{
    deleteActorsToDelete();

    for (vector<Actor*>::iterator actorIt = actors.begin(); actorIt != actors.end(); ++actorIt)
    {
        (*actorIt)->step();
    }

    for (vector<Actor*>::iterator actorIt = actors.begin(); actorIt != actors.end(); ++actorIt)
        for (vector<Actor*>::iterator actorIt2 = actors.begin(); actorIt2 != actors.end(); ++actorIt2)
        {
            if((*actorIt) != (*actorIt2))
            {
                (*actorIt)->interact((*actorIt2));

            }


        }

}

World::~World()
{
    for (vector<Actor*>::iterator actorIt = actors.begin(); actorIt != actors.end(); ++actorIt)
    {
        deleteActor( (*actorIt) );
    }

    deleteActorsToDelete();
}


void World::addActor(Actor* actor)
{
    actors.push_back(actor);
}

void World::deleteActor(Actor* actor)
{
    actors.erase(std::remove(actors.begin(), actors.end(), actor), actors.end());
    actorsToDelete.push_back(actor);
}


void World::deleteActorsToDelete()
{
    while(!actorsToDelete.empty())
    {
        Actor* actorToDelete = actorsToDelete.back();
        delete actorToDelete;
        actorsToDelete.pop_back();
    }
}

